<?php

namespace Pinpoint\CarouselManager\Block\Adminhtml\Carousel\Items;


class Form extends \Magento\Backend\Block\Template
{
    protected $_template = 'Pinpoint_CarouselManager::carousel/items/form.phtml';
    protected $coreRegistry;
    protected $carousel;
    protected $elementFactory;
    protected $form;

    public function __construct(\Magento\Backend\Block\Template\Context $context,
                                \Magento\Framework\Registry $coreRegistry,
                                \Magento\Framework\Data\Form\ElementFactory $elementFactory,
                                \Magento\Framework\Data\Form $form,
                                array $data = [])
    {
        $this->coreRegistry = $coreRegistry;
        $this->elementFactory = $elementFactory;
        $this->form = $form;
        parent::__construct($context, $data);
    }


    public function getCarousel()
    {
        if (!$this->carousel) {
            $carousel = $this->coreRegistry->registry('carousel');
            if ($carousel AND $carousel->getId()) {
                $this->carousel = $carousel;
            }
        }

        return $this->carousel;
    }

    public function getSlides()
    {
        if ($carousel = $this->getCarousel()) {
            return $carousel->getSlides();
        }
        return null;
    }

    public function getImageUploadField($name, $label = '')
    {
        $element = $this->elementFactory->create(\Magento\Framework\Data\Form\Element\Image::class, []);
        $element->setForm($this->form);
        $element->setLabel($label);
        $element->setName($name);
       // $element->setRenderer(\Pinpoint\CarouselManager\Block\Adminhtml\Carousel\Renderer\Image);
        $html = $element->toHtml();
        return $html;
    }
}