<?php

namespace Pinpoint\CarouselManager\Controller\Adminhtml\Carousel;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

/**
 * Class CarouselList
 * @package Pinpoint\CarouselManager
 */
class Imageupload extends Action
{
    const ADMIN_RESOURCE = 'Pinpoint_CarouselManager::carousel';

    /**
     * @var \Magento\Framework\Filesystem
     */
    protected $_filesystem;

    /**
     * @var \Magento\MediaStorage\Model\File\Uploader
     */
    protected $uploader;

    /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $storeManager;

    protected $directoryList;

    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    public function __construct(
        Context $context,
        \Magento\Framework\Filesystem $fileSystem,
        \Magento\MediaStorage\Model\File\UploaderFactory $uploader,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\App\Filesystem\DirectoryList $directoryList
    )
    {
        $this->_filesystem = $fileSystem;
        $this->uploader = $uploader;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->storeManager = $storeManager;
        $this->directoryList = $directoryList;

        parent::__construct($context);
    }

    public function execute()
    {
        /** @var \Magento\Framework\Controller\Result\Json $resultPage */
        $resultPage = $this->resultJsonFactory->create();
        if ($_FILES['block_image_upload_file']['name']) {
            try {
                $uploader = $this->uploader->create(['fileId' => 'block_image_upload_file']);
                $uploader->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
                $uploader->setAllowRenameFiles(true);
                $uploader->setFilesDispersion(true);
                // get media directory
                $mediaDirectory = $this->_filesystem->getDirectoryRead(\Magento\Framework\App\Filesystem\DirectoryList::MEDIA);
                // save the image to media directory
                $savePath = $mediaDirectory->getAbsolutePath() . 'pinpoint' . DIRECTORY_SEPARATOR;
                $save = $uploader->save($savePath, md5(rand() . time() . uniqid()) . "." . $uploader->getFileExtension());

                $mediaFolder = $this->directoryList->getUrlPath('media');

                //$save['file'] = DIRECTORY_SEPARATOR . 'pub' . DIRECTORY_SEPARATOR . 'media' . DIRECTORY_SEPARATOR . 'pinpoint' . $save['file'];
                $save['file']  = $mediaFolder . DIRECTORY_SEPARATOR . 'pinpoint' . $save['file'];
            } catch (Exception $e) {
                \Zend_Debug::dump($e->getMessage());
            }
        }
        return $resultPage->setData(['success' => true, 'file' => $save]);
    }
}
