<?php

namespace Pinpoint\CarouselManager\Controller\Adminhtml\Carousel;

use Magento\Backend\App\Action;

class Itemdelete extends \Magento\Backend\App\Action
{
    const ADMIN_RESOURCE = 'Pinpoint_CarouselManager::carousel';

    protected $resultJsonFactory;

    public function __construct(Action\Context $context,
                                \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory
    )
    {
        $this->resultJsonFactory = $resultJsonFactory;
        parent::__construct($context);
    }


    public function execute()
    {
        $resultPage = $this->resultJsonFactory->create();

        // check if we know what should be deleted
        $itemId = $this->getRequest()->getParam('itemId');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($itemId) {
            try {
                // init model and delete
                $model = $this->_objectManager->create('Pinpoint\CarouselManager\Model\Slide');
                $model->load($itemId);
                $carouselId = $model->getCarouselId();
                $model->delete();

                return $resultPage->setData(['success' => true]);

            } catch (\Exception $e) {
                return $resultPage->setData(['success' => false]);
            }
        }
        return $resultPage->setData(['success' => false]);
    }

}
